/* storage-graph.c generated by valac 0.54.3, the Vala compiler
 * generated from storage-graph.vala, do not modify */

/* storage-graph.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_STORAGE_GRAPH (usage_storage_graph_get_type ())
#define USAGE_STORAGE_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph))
#define USAGE_STORAGE_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraphClass))
#define USAGE_IS_STORAGE_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_GRAPH))
#define USAGE_IS_STORAGE_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_GRAPH))
#define USAGE_STORAGE_GRAPH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraphClass))

typedef struct _UsageStorageGraph UsageStorageGraph;
typedef struct _UsageStorageGraphClass UsageStorageGraphClass;
typedef struct _UsageStorageGraphPrivate UsageStorageGraphPrivate;

#define USAGE_TYPE_STORAGE_VIEW_ITEM (usage_storage_view_item_get_type ())
#define USAGE_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem))
#define USAGE_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))
#define USAGE_IS_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_IS_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_STORAGE_VIEW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))

typedef struct _UsageStorageViewItem UsageStorageViewItem;
typedef struct _UsageStorageViewItemClass UsageStorageViewItemClass;
enum  {
	USAGE_STORAGE_GRAPH_0_PROPERTY,
	USAGE_STORAGE_GRAPH_MODEL_PROPERTY,
	USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY,
	USAGE_STORAGE_GRAPH_NUM_PROPERTIES
};
static GParamSpec* usage_storage_graph_properties[USAGE_STORAGE_GRAPH_NUM_PROPERTIES];
typedef enum  {
	USAGE_STORAGE_GRAPH_CIRCLE_HOME,
	USAGE_STORAGE_GRAPH_CIRCLE_ROOT,
	USAGE_STORAGE_GRAPH_CIRCLE_BASE
} UsageStorageGraphCircle;

#define USAGE_STORAGE_GRAPH_TYPE_CIRCLE (usage_storage_graph_circle_get_type ())
typedef struct _UsageStorageViewItemPrivate UsageStorageViewItemPrivate;
typedef enum  {
	STORAGE_VIEW_TYPE_NONE,
	STORAGE_VIEW_TYPE_OS,
	STORAGE_VIEW_TYPE_UP_FOLDER,
	STORAGE_VIEW_TYPE_AVAILABLE_GRAPH,
	STORAGE_VIEW_TYPE_ROOT_ITEM
} StorageViewType;

#define TYPE_STORAGE_VIEW_TYPE (storage_view_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UsageStorageGraph {
	GtkDrawingArea parent_instance;
	UsageStorageGraphPrivate * priv;
};

struct _UsageStorageGraphClass {
	GtkDrawingAreaClass parent_class;
};

struct _UsageStorageGraphPrivate {
	GList* selected_items;
	GListStore* _model;
	guint64 selected_size;
	gboolean _root;
	guint _min_percentage_shown_files;
};

struct _UsageStorageViewItem {
	GObject parent_instance;
	UsageStorageViewItemPrivate * priv;
	gchar* uri;
	gchar* name;
	guint64 size;
	GFileType type;
	GUserDirectory* dir;
	gchar* ontology;
	StorageViewType custom_type;
};

struct _UsageStorageViewItemClass {
	GObjectClass parent_class;
};

static gint UsageStorageGraph_private_offset;
static gpointer usage_storage_graph_parent_class = NULL;

VALA_EXTERN GType usage_storage_graph_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageGraph, g_object_unref)
VALA_EXTERN GType usage_storage_view_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageViewItem, g_object_unref)
VALA_EXTERN GType usage_storage_graph_circle_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void usage_storage_graph_update_selected_items (UsageStorageGraph* self,
                                                GList* selected_items);
VALA_EXTERN GType storage_view_type_get_type (void) G_GNUC_CONST ;
static void usage_storage_graph_draw_circle (UsageStorageGraph* self,
                                      cairo_t* context,
                                      gdouble x,
                                      gdouble y,
                                      gdouble radius,
                                      gint section,
                                      UsageStorageGraphCircle circle);
VALA_EXTERN GListStore* usage_storage_graph_get_model (UsageStorageGraph* self);
VALA_EXTERN gdouble usage_storage_view_item_get_percentage (UsageStorageViewItem* self);
VALA_EXTERN guint usage_storage_graph_get_min_percentage_shown_files (UsageStorageGraph* self);
VALA_EXTERN const gchar* usage_storage_view_item_get_style_class (UsageStorageViewItem* self);
static gboolean usage_storage_graph_get_root (UsageStorageGraph* self);
VALA_EXTERN void usage_utils_generate_color (GdkRGBA* default_color,
                                 guint order,
                                 guint all_count,
                                 gboolean reverse,
                                 GdkRGBA* result);
VALA_EXTERN void usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                        GdkRGBA * value);
static gboolean usage_storage_graph_draw_storage_graph (UsageStorageGraph* self,
                                                 cairo_t* context);
static void usage_storage_graph_draw_selected_size_text (UsageStorageGraph* self,
                                                  cairo_t* context);
VALA_EXTERN gchar* usage_utils_format_size_values (guint64 value);
VALA_EXTERN UsageStorageGraph* usage_storage_graph_new (void);
VALA_EXTERN UsageStorageGraph* usage_storage_graph_construct (GType object_type);
static void usage_storage_graph_set_root (UsageStorageGraph* self,
                                   gboolean value);
VALA_EXTERN void usage_storage_graph_set_model (UsageStorageGraph* self,
                                    GListStore* value);
static gboolean _usage_storage_graph_draw_storage_graph_gtk_widget_draw (GtkWidget* _sender,
                                                                  cairo_t* cr,
                                                                  gpointer self);
VALA_EXTERN void usage_storage_graph_set_min_percentage_shown_files (UsageStorageGraph* self,
                                                         guint value);
static void usage_storage_graph_finalize (GObject * obj);
static GType usage_storage_graph_get_type_once (void);
static void _vala_usage_storage_graph_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_usage_storage_graph_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_storage_graph_get_instance_private (UsageStorageGraph* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageGraph_private_offset);
}

static GType
usage_storage_graph_circle_get_type_once (void)
{
	static const GEnumValue values[] = {{USAGE_STORAGE_GRAPH_CIRCLE_HOME, "USAGE_STORAGE_GRAPH_CIRCLE_HOME", "home"}, {USAGE_STORAGE_GRAPH_CIRCLE_ROOT, "USAGE_STORAGE_GRAPH_CIRCLE_ROOT", "root"}, {USAGE_STORAGE_GRAPH_CIRCLE_BASE, "USAGE_STORAGE_GRAPH_CIRCLE_BASE", "base"}, {0, NULL, NULL}};
	GType usage_storage_graph_circle_type_id;
	usage_storage_graph_circle_type_id = g_enum_register_static ("UsageStorageGraphCircle", values);
	return usage_storage_graph_circle_type_id;
}

GType
usage_storage_graph_circle_get_type (void)
{
	static volatile gsize usage_storage_graph_circle_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_graph_circle_type_id__volatile)) {
		GType usage_storage_graph_circle_type_id;
		usage_storage_graph_circle_type_id = usage_storage_graph_circle_get_type_once ();
		g_once_init_leave (&usage_storage_graph_circle_type_id__volatile, usage_storage_graph_circle_type_id);
	}
	return usage_storage_graph_circle_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
usage_storage_graph_update_selected_items (UsageStorageGraph* self,
                                           GList* selected_items)
{
	guint64 size = 0ULL;
	g_return_if_fail (self != NULL);
	self->priv->selected_items = selected_items;
	size = (guint64) 0;
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
		item_collection = selected_items;
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
			UsageStorageViewItem* _tmp0_;
			UsageStorageViewItem* item = NULL;
			_tmp0_ = _g_object_ref0 ((UsageStorageViewItem*) item_it->data);
			item = _tmp0_;
			{
				UsageStorageViewItem* _tmp1_;
				_tmp1_ = item;
				size += _tmp1_->size;
				_g_object_unref0 (item);
			}
		}
	}
	self->priv->selected_size = size;
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
usage_storage_graph_draw_circle (UsageStorageGraph* self,
                                 cairo_t* context,
                                 gdouble x,
                                 gdouble y,
                                 gdouble radius,
                                 gint section,
                                 UsageStorageGraphCircle circle)
{
	gdouble start_angle = 0.0;
	gdouble final_angle = 0.0;
	gdouble ratio = 0.0;
	guint shown_items_number = 0U;
	GdkRGBA background_color = {0};
	GtkWidget* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	GdkRGBA _tmp4_ = {0};
	GdkRGBA foreground_color = {0};
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GdkRGBA _tmp7_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	start_angle = (gdouble) 0;
	final_angle = (-G_PI) / 2.0;
	ratio = (gdouble) 0;
	shown_items_number = (guint) 1;
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp1_ = gtk_widget_get_style_context (_tmp0_);
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
	gtk_style_context_get_background_color (_tmp1_, gtk_style_context_get_state (_tmp3_), &_tmp4_);
	background_color = _tmp4_;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_get_color (_tmp5_, gtk_style_context_get_state (_tmp6_), &_tmp7_);
	foreground_color = _tmp7_;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				GListStore* _tmp10_;
				GListStore* _tmp11_;
				UsageStorageViewItem* item = NULL;
				GListStore* _tmp12_;
				GListStore* _tmp13_;
				GObject* _tmp14_;
				UsageStorageViewItem* _tmp15_;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				UsageStorageViewItem* _tmp24_;
				gdouble _tmp25_;
				gdouble _tmp26_;
				guint _tmp27_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = usage_storage_graph_get_model (self);
				_tmp11_ = _tmp10_;
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp11_))) {
					break;
				}
				_tmp12_ = usage_storage_graph_get_model (self);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_list_model_get_item ((GListModel*) _tmp13_, (guint) i);
				_tmp15_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp14_) ? ((UsageStorageViewItem*) _tmp14_) : NULL;
				if (_tmp15_ == NULL) {
					_g_object_unref0 (_tmp14_);
				}
				item = _tmp15_;
				if (i > 0) {
					_tmp17_ = i < 3;
				} else {
					_tmp17_ = FALSE;
				}
				if (_tmp17_) {
					UsageStorageViewItem* _tmp18_;
					gdouble _tmp19_;
					gdouble _tmp20_;
					guint _tmp21_;
					_tmp18_ = item;
					_tmp19_ = usage_storage_view_item_get_percentage (_tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = self->priv->_min_percentage_shown_files;
					_tmp16_ = _tmp20_ < ((gdouble) _tmp21_);
				} else {
					_tmp16_ = FALSE;
				}
				if (_tmp16_) {
					GListStore* _tmp22_;
					GListStore* _tmp23_;
					_tmp22_ = usage_storage_graph_get_model (self);
					_tmp23_ = _tmp22_;
					shown_items_number = g_list_model_get_n_items ((GListModel*) _tmp23_);
					_g_object_unref0 (item);
					continue;
				}
				_tmp24_ = item;
				_tmp25_ = usage_storage_view_item_get_percentage (_tmp24_);
				_tmp26_ = _tmp25_;
				_tmp27_ = self->priv->_min_percentage_shown_files;
				if (_tmp26_ > ((gdouble) _tmp27_)) {
					shown_items_number = shown_items_number + 1;
				}
				_g_object_unref0 (item);
			}
		}
	}
	if (shown_items_number > ((guint) 1)) {
		GdkRGBA _tmp70_;
		GdkRGBA _tmp71_;
		if (shown_items_number < ((guint) 3)) {
			shown_items_number = (guint) 3;
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp28_ = FALSE;
				_tmp28_ = TRUE;
				while (TRUE) {
					GListStore* _tmp30_;
					GListStore* _tmp31_;
					UsageStorageViewItem* item = NULL;
					GListStore* _tmp32_;
					GListStore* _tmp33_;
					GObject* _tmp34_;
					UsageStorageViewItem* _tmp35_;
					gdouble item_radius = 0.0;
					gboolean _tmp36_ = FALSE;
					UsageStorageViewItem* _tmp37_;
					StorageViewType _tmp38_;
					GtkStyleContext* style_context = NULL;
					GtkStyleContext* _tmp40_;
					GtkStyleContext* _tmp41_;
					GtkStyleContext* _tmp42_;
					UsageStorageViewItem* _tmp43_;
					const gchar* _tmp44_;
					const gchar* _tmp45_;
					GdkRGBA base_color = {0};
					GtkStyleContext* _tmp46_;
					GtkStyleContext* _tmp47_;
					GdkRGBA _tmp48_ = {0};
					GtkStyleContext* _tmp49_;
					UsageStorageViewItem* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					GdkRGBA fill_color = {0};
					GdkRGBA _tmp53_;
					gboolean _tmp54_;
					GList* _tmp59_;
					UsageStorageViewItem* _tmp60_;
					GList* _tmp61_;
					UsageStorageViewItem* _tmp62_;
					gdouble _tmp63_;
					gdouble _tmp64_;
					GdkRGBA _tmp68_;
					GdkRGBA _tmp69_;
					if (!_tmp28_) {
						gint _tmp29_;
						_tmp29_ = i;
						i = _tmp29_ + 1;
					}
					_tmp28_ = FALSE;
					_tmp30_ = usage_storage_graph_get_model (self);
					_tmp31_ = _tmp30_;
					if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp31_))) {
						break;
					}
					_tmp32_ = usage_storage_graph_get_model (self);
					_tmp33_ = _tmp32_;
					_tmp34_ = g_list_model_get_item ((GListModel*) _tmp33_, (guint) i);
					_tmp35_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp34_) ? ((UsageStorageViewItem*) _tmp34_) : NULL;
					if (_tmp35_ == NULL) {
						_g_object_unref0 (_tmp34_);
					}
					item = _tmp35_;
					item_radius = radius;
					_tmp37_ = item;
					_tmp38_ = _tmp37_->custom_type;
					if (_tmp38_ == STORAGE_VIEW_TYPE_UP_FOLDER) {
						_tmp36_ = TRUE;
					} else {
						UsageStorageViewItem* _tmp39_;
						_tmp39_ = item;
						_tmp36_ = _tmp39_->size == ((guint64) 0);
					}
					if (_tmp36_) {
						_g_object_unref0 (item);
						continue;
					}
					_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) self);
					_tmp41_ = _g_object_ref0 (_tmp40_);
					style_context = _tmp41_;
					_tmp42_ = style_context;
					_tmp43_ = item;
					_tmp44_ = usage_storage_view_item_get_style_class (_tmp43_);
					_tmp45_ = _tmp44_;
					gtk_style_context_add_class (_tmp42_, _tmp45_);
					_tmp46_ = style_context;
					_tmp47_ = style_context;
					gtk_style_context_get_background_color (_tmp46_, gtk_style_context_get_state (_tmp47_), &_tmp48_);
					base_color = _tmp48_;
					_tmp49_ = style_context;
					_tmp50_ = item;
					_tmp51_ = usage_storage_view_item_get_style_class (_tmp50_);
					_tmp52_ = _tmp51_;
					gtk_style_context_remove_class (_tmp49_, _tmp52_);
					_tmp53_ = base_color;
					fill_color = _tmp53_;
					_tmp54_ = self->priv->_root;
					if (!_tmp54_) {
						GdkRGBA _tmp55_;
						GdkRGBA _tmp56_ = {0};
						UsageStorageViewItem* _tmp57_;
						GdkRGBA _tmp58_;
						_tmp55_ = base_color;
						usage_utils_generate_color (&_tmp55_, (guint) i, shown_items_number, TRUE, &_tmp56_);
						fill_color = _tmp56_;
						_tmp57_ = item;
						_tmp58_ = fill_color;
						usage_storage_view_item_set_color (_tmp57_, &_tmp58_);
					}
					_tmp59_ = self->priv->selected_items;
					_tmp60_ = item;
					_tmp61_ = g_list_find (_tmp59_, _tmp60_);
					if (_tmp61_ != NULL) {
						item_radius += radius / 6;
					}
					cairo_set_line_width (context, 2.0);
					start_angle = final_angle;
					_tmp62_ = item;
					_tmp63_ = usage_storage_view_item_get_percentage (_tmp62_);
					_tmp64_ = _tmp63_;
					if (_tmp64_ < 0.3) {
						ratio = ratio + (((gdouble) 0.3) / 100);
					} else {
						UsageStorageViewItem* _tmp65_;
						gdouble _tmp66_;
						gdouble _tmp67_;
						_tmp65_ = item;
						_tmp66_ = usage_storage_view_item_get_percentage (_tmp65_);
						_tmp67_ = _tmp66_;
						ratio = ratio + (((gdouble) _tmp67_) / 100);
					}
					final_angle = ((ratio * 2) * G_PI) - (G_PI / 2.0);
					if (final_angle >= ((2 * G_PI) - (G_PI / 2.0))) {
						final_angle = (2 * G_PI) - (G_PI / 2.0);
					}
					cairo_move_to (context, x, y);
					_tmp68_ = fill_color;
					gdk_cairo_set_source_rgba (context, &_tmp68_);
					cairo_arc (context, x, y, item_radius, start_angle, final_angle);
					cairo_line_to (context, x, y);
					cairo_fill_preserve (context);
					_tmp69_ = foreground_color;
					gdk_cairo_set_source_rgba (context, &_tmp69_);
					cairo_stroke (context);
					if (start_angle >= ((2 * G_PI) - (G_PI / 2.0))) {
						_g_object_unref0 (style_context);
						_g_object_unref0 (item);
						break;
					}
					_g_object_unref0 (style_context);
					_g_object_unref0 (item);
				}
			}
		}
		cairo_move_to (context, x, y);
		cairo_line_to (context, x, y - radius);
		cairo_stroke (context);
		cairo_arc (context, x, y, radius / 1.8, (gdouble) 0, 2 * G_PI);
		_tmp70_ = background_color;
		gdk_cairo_set_source_rgba (context, &_tmp70_);
		cairo_fill_preserve (context);
		_tmp71_ = foreground_color;
		gdk_cairo_set_source_rgba (context, &_tmp71_);
		cairo_stroke (context);
	}
}

static gboolean
usage_storage_graph_draw_storage_graph (UsageStorageGraph* self,
                                        cairo_t* context)
{
	gint height = 0;
	gint width = 0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble radius = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	x = (gdouble) 0;
	y = (gdouble) 0;
	radius = (gdouble) 0;
	radius = MIN (width, height) / 2.0;
	radius -= radius / 4;
	x = width / 2.0;
	y = height / 2.0;
	usage_storage_graph_draw_circle (self, context, x, y, radius, 0, USAGE_STORAGE_GRAPH_CIRCLE_BASE);
	usage_storage_graph_draw_selected_size_text (self, context);
	result = TRUE;
	return result;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static void
usage_storage_graph_draw_selected_size_text (UsageStorageGraph* self,
                                             cairo_t* context)
{
	PangoLayout* layout = NULL;
	PangoLayout* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	gint height = 0;
	gint width = 0;
	gdouble radius = 0.0;
	GdkRGBA text_color = {0};
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkWidget* _tmp4_;
	GtkStyleContext* _tmp5_;
	GdkRGBA _tmp6_ = {0};
	gchar* text_color_string = NULL;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	GdkRGBA _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* markup = NULL;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	PangoLayout* _tmp30_;
	const gchar* _tmp31_;
	PangoRectangle layout_rect = {0};
	PangoLayout* _tmp32_;
	PangoRectangle _tmp33_ = {0};
	PangoLayout* _tmp34_;
	gint x = 0;
	PangoRectangle _tmp35_;
	gint y = 0;
	PangoRectangle _tmp36_;
	GtkStyleContext* _tmp37_;
	PangoLayout* _tmp38_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	if (self->priv->selected_size == ((guint64) 0)) {
		return;
	}
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
	layout = _tmp0_;
	_tmp1_ = usage_utils_format_size_values (self->priv->selected_size);
	text = _tmp1_;
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	radius = (gdouble) (MIN (width, height) / 22);
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
	_tmp4_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp5_ = gtk_widget_get_style_context (_tmp4_);
	gtk_style_context_get_color (_tmp3_, gtk_style_context_get_state (_tmp5_), &_tmp6_);
	text_color = _tmp6_;
	_tmp7_ = text_color;
	_tmp8_ = text_color;
	_tmp9_ = text_color;
	_tmp10_ = g_strdup_printf ("#%02x%02x%02x", (guint) round (_tmp7_.red * 255), (guint) round (_tmp8_.green * 255), (guint) round (_tmp9_.blue * 255));
	_tmp11_ = _tmp10_;
	_tmp12_ = g_utf8_strup (_tmp11_, (gssize) -1);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	text_color_string = _tmp13_;
	_tmp14_ = text_color_string;
	_tmp15_ = g_strconcat ("<span foreground='", _tmp14_, NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strconcat (_tmp16_, "' font='", NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = double_to_string (radius);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat (_tmp18_, _tmp20_, NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_strconcat (_tmp22_, "'><b>", NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = text;
	_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strconcat (_tmp27_, "</b></span>", NULL);
	_tmp29_ = _tmp28_;
	_g_free0 (_tmp27_);
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	markup = _tmp29_;
	_tmp30_ = layout;
	_tmp31_ = markup;
	pango_layout_set_markup (_tmp30_, _tmp31_, -1);
	_tmp32_ = layout;
	pango_layout_get_pixel_extents (_tmp32_, NULL, &_tmp33_);
	layout_rect = _tmp33_;
	_tmp34_ = layout;
	pango_layout_set_alignment (_tmp34_, PANGO_ALIGN_CENTER);
	_tmp35_ = layout_rect;
	x = (width - _tmp35_.width) / 2;
	_tmp36_ = layout_rect;
	y = (height - _tmp36_.height) / 2;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp38_ = layout;
	gtk_render_layout (_tmp37_, context, (gdouble) x, (gdouble) y, _tmp38_);
	_g_free0 (markup);
	_g_free0 (text_color_string);
	_g_free0 (text);
	_g_object_unref0 (layout);
}

UsageStorageGraph*
usage_storage_graph_construct (GType object_type)
{
	UsageStorageGraph * self = NULL;
	self = (UsageStorageGraph*) g_object_new (object_type, NULL);
	return self;
}

UsageStorageGraph*
usage_storage_graph_new (void)
{
	return usage_storage_graph_construct (USAGE_TYPE_STORAGE_GRAPH);
}

static gboolean
usage_storage_graph_get_root (UsageStorageGraph* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_root;
	return result;
}

static void
usage_storage_graph_set_root (UsageStorageGraph* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_root = value;
}

GListStore*
usage_storage_graph_get_model (UsageStorageGraph* self)
{
	GListStore* result;
	GListStore* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	result = _tmp0_;
	return result;
}

static gboolean
_usage_storage_graph_draw_storage_graph_gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self)
{
	gboolean result;
	result = usage_storage_graph_draw_storage_graph ((UsageStorageGraph*) self, cr);
	return result;
}

void
usage_storage_graph_set_model (UsageStorageGraph* self,
                               GListStore* value)
{
	g_return_if_fail (self != NULL);
	self->priv->_model = value;
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _usage_storage_graph_draw_storage_graph_gtk_widget_draw, self, 0);
	gtk_widget_queue_draw ((GtkWidget*) self);
	usage_storage_graph_set_root (self, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				UsageStorageViewItem* item = NULL;
				GListStore* _tmp2_;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				UsageStorageViewItem* _tmp5_;
				UsageStorageViewItem* _tmp6_;
				StorageViewType _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) value))) {
					break;
				}
				_tmp2_ = usage_storage_graph_get_model (self);
				_tmp3_ = _tmp2_;
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, (guint) i);
				_tmp5_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp4_) ? ((UsageStorageViewItem*) _tmp4_) : NULL;
				if (_tmp5_ == NULL) {
					_g_object_unref0 (_tmp4_);
				}
				item = _tmp5_;
				_tmp6_ = item;
				_tmp7_ = _tmp6_->custom_type;
				if (_tmp7_ == STORAGE_VIEW_TYPE_OS) {
					usage_storage_graph_set_root (self, TRUE);
					_g_object_unref0 (item);
					break;
				}
				_g_object_unref0 (item);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MODEL_PROPERTY]);
}

guint
usage_storage_graph_get_min_percentage_shown_files (UsageStorageGraph* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_min_percentage_shown_files;
	return result;
}

void
usage_storage_graph_set_min_percentage_shown_files (UsageStorageGraph* self,
                                                    guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = usage_storage_graph_get_min_percentage_shown_files (self);
	if (old_value != value) {
		self->priv->_min_percentage_shown_files = value;
		g_object_notify_by_pspec ((GObject *) self, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY]);
	}
}

static void
usage_storage_graph_base_init (UsageStorageGraphClass * klass)
{
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "StorageGraph");
}

static void
usage_storage_graph_class_init (UsageStorageGraphClass * klass,
                                gpointer klass_data)
{
	usage_storage_graph_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageStorageGraph_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_storage_graph_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_storage_graph_set_property;
	G_OBJECT_CLASS (klass)->finalize = usage_storage_graph_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_GRAPH_MODEL_PROPERTY, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY] = g_param_spec_uint ("min-percentage-shown-files", "min-percentage-shown-files", "min-percentage-shown-files", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
usage_storage_graph_instance_init (UsageStorageGraph * self,
                                   gpointer klass)
{
	self->priv = usage_storage_graph_get_instance_private (self);
	self->priv->selected_size = (guint64) 0;
}

static void
usage_storage_graph_finalize (GObject * obj)
{
	UsageStorageGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
	G_OBJECT_CLASS (usage_storage_graph_parent_class)->finalize (obj);
}

static GType
usage_storage_graph_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageStorageGraphClass), (GBaseInitFunc) usage_storage_graph_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_graph_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageGraph), 0, (GInstanceInitFunc) usage_storage_graph_instance_init, NULL };
	GType usage_storage_graph_type_id;
	usage_storage_graph_type_id = g_type_register_static (gtk_drawing_area_get_type (), "UsageStorageGraph", &g_define_type_info, 0);
	UsageStorageGraph_private_offset = g_type_add_instance_private (usage_storage_graph_type_id, sizeof (UsageStorageGraphPrivate));
	return usage_storage_graph_type_id;
}

GType
usage_storage_graph_get_type (void)
{
	static volatile gsize usage_storage_graph_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_graph_type_id__volatile)) {
		GType usage_storage_graph_type_id;
		usage_storage_graph_type_id = usage_storage_graph_get_type_once ();
		g_once_init_leave (&usage_storage_graph_type_id__volatile, usage_storage_graph_type_id);
	}
	return usage_storage_graph_type_id__volatile;
}

static void
_vala_usage_storage_graph_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	UsageStorageGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
	switch (property_id) {
		case USAGE_STORAGE_GRAPH_MODEL_PROPERTY:
		g_value_set_object (value, usage_storage_graph_get_model (self));
		break;
		case USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY:
		g_value_set_uint (value, usage_storage_graph_get_min_percentage_shown_files (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_usage_storage_graph_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	UsageStorageGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
	switch (property_id) {
		case USAGE_STORAGE_GRAPH_MODEL_PROPERTY:
		usage_storage_graph_set_model (self, g_value_get_object (value));
		break;
		case USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY:
		usage_storage_graph_set_min_percentage_shown_files (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

