/* storage-view-item.c generated by valac 0.54.3, the Vala compiler
 * generated from storage-view-item.vala, do not modify */

/* storage-view-item.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Felipe Borges <felipeborges@gnome.org>
 *          Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	STORAGE_VIEW_TYPE_NONE,
	STORAGE_VIEW_TYPE_OS,
	STORAGE_VIEW_TYPE_UP_FOLDER,
	STORAGE_VIEW_TYPE_AVAILABLE_GRAPH,
	STORAGE_VIEW_TYPE_ROOT_ITEM
} StorageViewType;

#define TYPE_STORAGE_VIEW_TYPE (storage_view_type_get_type ())

#define USAGE_TYPE_STORAGE_VIEW_ITEM (usage_storage_view_item_get_type ())
#define USAGE_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem))
#define USAGE_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))
#define USAGE_IS_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_IS_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_STORAGE_VIEW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))

typedef struct _UsageStorageViewItem UsageStorageViewItem;
typedef struct _UsageStorageViewItemClass UsageStorageViewItemClass;
typedef struct _UsageStorageViewItemPrivate UsageStorageViewItemPrivate;
enum  {
	USAGE_STORAGE_VIEW_ITEM_0_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES
};
static GParamSpec* usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UsageStorageViewItem {
	GObject parent_instance;
	UsageStorageViewItemPrivate * priv;
	gchar* uri;
	gchar* name;
	guint64 size;
	GFileType type;
	GUserDirectory* dir;
	gchar* ontology;
	StorageViewType custom_type;
};

struct _UsageStorageViewItemClass {
	GObjectClass parent_class;
};

struct _UsageStorageViewItemPrivate {
	gdouble _percentage;
	gboolean _loaded;
	GdkRGBA _color;
	gchar* _style_class;
};

static gint UsageStorageViewItem_private_offset;
static gpointer usage_storage_view_item_parent_class = NULL;

VALA_EXTERN GType storage_view_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType usage_storage_view_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageViewItem, g_object_unref)
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_from_file (GFile* file);
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_new (void);
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_construct (GType object_type);
static void usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                              const gchar* value);
static gboolean _usage_storage_view_item_show_check_button (UsageStorageViewItem* self);
VALA_EXTERN gdouble usage_storage_view_item_get_percentage (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                             gdouble value);
VALA_EXTERN gboolean usage_storage_view_item_get_loaded (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                         gboolean value);
VALA_EXTERN void usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                        GdkRGBA * result);
VALA_EXTERN void usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                        GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
VALA_EXTERN const gchar* usage_storage_view_item_get_style_class (UsageStorageViewItem* self);
VALA_EXTERN gboolean usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self);
static void usage_storage_view_item_finalize (GObject * obj);
static GType usage_storage_view_item_get_type_once (void);
static void _vala_usage_storage_view_item_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_usage_storage_view_item_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
storage_view_type_get_type_once (void)
{
	static const GEnumValue values[] = {{STORAGE_VIEW_TYPE_NONE, "STORAGE_VIEW_TYPE_NONE", "none"}, {STORAGE_VIEW_TYPE_OS, "STORAGE_VIEW_TYPE_OS", "os"}, {STORAGE_VIEW_TYPE_UP_FOLDER, "STORAGE_VIEW_TYPE_UP_FOLDER", "up-folder"}, {STORAGE_VIEW_TYPE_AVAILABLE_GRAPH, "STORAGE_VIEW_TYPE_AVAILABLE_GRAPH", "available-graph"}, {STORAGE_VIEW_TYPE_ROOT_ITEM, "STORAGE_VIEW_TYPE_ROOT_ITEM", "root-item"}, {0, NULL, NULL}};
	GType storage_view_type_type_id;
	storage_view_type_type_id = g_enum_register_static ("StorageViewType", values);
	return storage_view_type_type_id;
}

GType
storage_view_type_get_type (void)
{
	static volatile gsize storage_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&storage_view_type_type_id__volatile)) {
		GType storage_view_type_type_id;
		storage_view_type_type_id = storage_view_type_get_type_once ();
		g_once_init_leave (&storage_view_type_type_id__volatile, storage_view_type_type_id);
	}
	return storage_view_type_type_id__volatile;
}

static inline gpointer
usage_storage_view_item_get_instance_private (UsageStorageViewItem* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageViewItem_private_offset);
}

UsageStorageViewItem*
usage_storage_view_item_from_file (GFile* file)
{
	UsageStorageViewItem* item = NULL;
	UsageStorageViewItem* _tmp0_;
	UsageStorageViewItem* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	UsageStorageViewItem* result = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = usage_storage_view_item_new ();
	item = _tmp0_;
	_tmp1_ = item;
	_tmp2_ = g_file_get_uri (file);
	_g_free0 (_tmp1_->uri);
	_tmp1_->uri = _tmp2_;
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp3_;
		UsageStorageViewItem* _tmp4_;
		GFileInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		UsageStorageViewItem* _tmp8_;
		GFileInfo* _tmp9_;
		UsageStorageViewItem* _tmp10_;
		GFileInfo* _tmp11_;
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_TRASH_ORIG_PATH, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
		info = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = item;
		_tmp5_ = info;
		_tmp6_ = g_file_info_get_name (_tmp5_);
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (_tmp4_->name);
		_tmp4_->name = _tmp7_;
		_tmp8_ = item;
		_tmp9_ = info;
		_tmp8_->size = (guint64) g_file_info_get_size (_tmp9_);
		_tmp10_ = item;
		_tmp11_ = info;
		_tmp10_->type = g_file_info_get_file_type (_tmp11_);
		_g_object_unref0 (info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		result = NULL;
		_g_object_unref0 (item);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (item);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = item;
	return result;
}

static void
usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self)
{
	GFileType _tmp0_;
	GUserDirectory* _tmp1_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
	static GQuark _tmp5_label0 = 0;
	static GQuark _tmp5_label1 = 0;
	static GQuark _tmp5_label2 = 0;
	static GQuark _tmp5_label3 = 0;
	static GQuark _tmp5_label4 = 0;
	static GQuark _tmp5_label5 = 0;
	static GQuark _tmp5_label6 = 0;
	StorageViewType _tmp7_;
	const gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->type;
	if (_tmp0_ == G_FILE_TYPE_DIRECTORY) {
		usage_storage_view_item_set_style_class (self, "folders");
	}
	_tmp1_ = self->dir;
	if (_tmp1_ != NULL) {
		GUserDirectory* _tmp2_;
		_tmp2_ = self->dir;
		switch (*_tmp2_) {
			case G_USER_DIRECTORY_PICTURES:
			{
				usage_storage_view_item_set_style_class (self, "pictures");
				break;
			}
			case G_USER_DIRECTORY_VIDEOS:
			{
				usage_storage_view_item_set_style_class (self, "videos");
				break;
			}
			case G_USER_DIRECTORY_DOCUMENTS:
			{
				usage_storage_view_item_set_style_class (self, "documents");
				break;
			}
			case G_USER_DIRECTORY_MUSIC:
			{
				usage_storage_view_item_set_style_class (self, "music");
				break;
			}
			case G_USER_DIRECTORY_DOWNLOAD:
			{
				usage_storage_view_item_set_style_class (self, "downloads");
				break;
			}
			default:
			break;
		}
	}
	_tmp3_ = self->ontology;
	_tmp4_ = _tmp3_;
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) {
		switch (0) {
			default:
			{
				usage_storage_view_item_set_style_class (self, "music");
				break;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("nmm#Photo")))) {
		switch (0) {
			default:
			{
				usage_storage_view_item_set_style_class (self, "pictures");
				break;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("nmm#Video")))) {
		switch (0) {
			default:
			{
				usage_storage_view_item_set_style_class (self, "videos");
				break;
			}
		}
	} else if ((((_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument")))) || (_tmp6_ == ((0 != _tmp5_label4) ? _tmp5_label4 : (_tmp5_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp6_ == ((0 != _tmp5_label5) ? _tmp5_label5 : (_tmp5_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp6_ == ((0 != _tmp5_label6) ? _tmp5_label6 : (_tmp5_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
		switch (0) {
			default:
			{
				usage_storage_view_item_set_style_class (self, "documents");
				break;
			}
		}
	}
	_tmp7_ = self->custom_type;
	if (_tmp7_ != STORAGE_VIEW_TYPE_NONE) {
		StorageViewType _tmp8_;
		_tmp8_ = self->custom_type;
		switch (_tmp8_) {
			case STORAGE_VIEW_TYPE_OS:
			{
				usage_storage_view_item_set_style_class (self, "os-tag");
				break;
			}
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
			{
				usage_storage_view_item_set_style_class (self, "available-tag");
				break;
			}
			default:
			break;
		}
	}
	_tmp9_ = self->priv->_style_class;
	if (_tmp9_ == NULL) {
		usage_storage_view_item_set_style_class (self, "files");
	}
}

static gboolean
_usage_storage_view_item_show_check_button (UsageStorageViewItem* self)
{
	StorageViewType _tmp0_;
	GUserDirectory* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
	static GQuark _tmp6_label0 = 0;
	static GQuark _tmp6_label1 = 0;
	static GQuark _tmp6_label2 = 0;
	static GQuark _tmp6_label3 = 0;
	static GQuark _tmp6_label4 = 0;
	static GQuark _tmp6_label5 = 0;
	static GQuark _tmp6_label6 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->custom_type;
	if (_tmp0_ != STORAGE_VIEW_TYPE_NONE) {
		StorageViewType _tmp1_;
		_tmp1_ = self->custom_type;
		switch (_tmp1_) {
			case STORAGE_VIEW_TYPE_OS:
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
			case STORAGE_VIEW_TYPE_UP_FOLDER:
			{
				result = FALSE;
				return result;
			}
			default:
			break;
		}
	}
	_tmp2_ = self->dir;
	if (_tmp2_ != NULL) {
		GUserDirectory* _tmp3_;
		_tmp3_ = self->dir;
		switch (*_tmp3_) {
			case G_USER_DIRECTORY_PICTURES:
			case G_USER_DIRECTORY_VIDEOS:
			case G_USER_DIRECTORY_DOCUMENTS:
			case G_USER_DIRECTORY_MUSIC:
			case G_USER_DIRECTORY_DOWNLOAD:
			{
				result = TRUE;
				return result;
			}
			default:
			break;
		}
	}
	_tmp4_ = self->ontology;
	_tmp5_ = _tmp4_;
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
	if (((((((_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) || (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("nmm#Photo"))))) || (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("nmm#Video"))))) || (_tmp7_ == ((0 != _tmp6_label3) ? _tmp6_label3 : (_tmp6_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument"))))) || (_tmp7_ == ((0 != _tmp6_label4) ? _tmp6_label4 : (_tmp6_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp7_ == ((0 != _tmp6_label5) ? _tmp6_label5 : (_tmp6_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp7_ == ((0 != _tmp6_label6) ? _tmp6_label6 : (_tmp6_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
		switch (0) {
			default:
			{
				result = TRUE;
				return result;
			}
		}
	}
	result = FALSE;
	return result;
}

UsageStorageViewItem*
usage_storage_view_item_construct (GType object_type)
{
	UsageStorageViewItem * self = NULL;
	self = (UsageStorageViewItem*) g_object_new (object_type, NULL);
	return self;
}

UsageStorageViewItem*
usage_storage_view_item_new (void)
{
	return usage_storage_view_item_construct (USAGE_TYPE_STORAGE_VIEW_ITEM);
}

gdouble
usage_storage_view_item_get_percentage (UsageStorageViewItem* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_percentage;
	return result;
}

void
usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                        gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = usage_storage_view_item_get_percentage (self);
	if (old_value != value) {
		self->priv->_percentage = value;
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY]);
	}
}

gboolean
usage_storage_view_item_get_loaded (UsageStorageViewItem* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_loaded;
	return result;
}

void
usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = usage_storage_view_item_get_loaded (self);
	if (old_value != value) {
		self->priv->_loaded = value;
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY]);
	}
}

void
usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                   GdkRGBA * result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_color;
	*result = _tmp0_;
	return;
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->red != s2->red) {
		return FALSE;
	}
	if (s1->green != s2->green) {
		return FALSE;
	}
	if (s1->blue != s2->blue) {
		return FALSE;
	}
	if (s1->alpha != s2->alpha) {
		return FALSE;
	}
	return TRUE;
}

void
usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                   GdkRGBA * value)
{
	GdkRGBA old_value;
	g_return_if_fail (self != NULL);
	usage_storage_view_item_get_color (self, &old_value);
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
		GdkRGBA _tmp0_;
		_tmp0_ = *value;
		self->priv->_color = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY]);
	}
}

const gchar*
usage_storage_view_item_get_style_class (UsageStorageViewItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_style_class;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_style_class;
		result = _tmp1_;
		return result;
	}
	usage_storage_view_item_setup_tag_style (self);
	_tmp2_ = self->priv->_style_class;
	result = _tmp2_;
	return result;
}

void
usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_style_class);
	self->priv->_style_class = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY]);
}

gboolean
usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = _usage_storage_view_item_show_check_button (self);
	return result;
}

static void
usage_storage_view_item_class_init (UsageStorageViewItemClass * klass,
                                    gpointer klass_data)
{
	usage_storage_view_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageStorageViewItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_storage_view_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_storage_view_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = usage_storage_view_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY] = g_param_spec_boolean ("loaded", "loaded", "loaded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY] = g_param_spec_string ("style-class", "style-class", "style-class", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY] = g_param_spec_boolean ("show-check-button", "show-check-button", "show-check-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
usage_storage_view_item_instance_init (UsageStorageViewItem * self,
                                       gpointer klass)
{
	self->priv = usage_storage_view_item_get_instance_private (self);
	self->priv->_loaded = FALSE;
	self->custom_type = STORAGE_VIEW_TYPE_NONE;
	self->priv->_style_class = NULL;
}

static void
usage_storage_view_item_finalize (GObject * obj)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
	_g_free0 (self->uri);
	_g_free0 (self->name);
	_g_free0 (self->dir);
	_g_free0 (self->ontology);
	_g_free0 (self->priv->_style_class);
	G_OBJECT_CLASS (usage_storage_view_item_parent_class)->finalize (obj);
}

static GType
usage_storage_view_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageStorageViewItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_view_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageViewItem), 0, (GInstanceInitFunc) usage_storage_view_item_instance_init, NULL };
	GType usage_storage_view_item_type_id;
	usage_storage_view_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageStorageViewItem", &g_define_type_info, 0);
	UsageStorageViewItem_private_offset = g_type_add_instance_private (usage_storage_view_item_type_id, sizeof (UsageStorageViewItemPrivate));
	return usage_storage_view_item_type_id;
}

GType
usage_storage_view_item_get_type (void)
{
	static volatile gsize usage_storage_view_item_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_view_item_type_id__volatile)) {
		GType usage_storage_view_item_type_id;
		usage_storage_view_item_type_id = usage_storage_view_item_get_type_once ();
		g_once_init_leave (&usage_storage_view_item_type_id__volatile, usage_storage_view_item_type_id);
	}
	return usage_storage_view_item_type_id__volatile;
}

static void
_vala_usage_storage_view_item_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
	switch (property_id) {
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
		g_value_set_double (value, usage_storage_view_item_get_percentage (self));
		break;
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
		g_value_set_boolean (value, usage_storage_view_item_get_loaded (self));
		break;
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
		{
			GdkRGBA boxed;
			usage_storage_view_item_get_color (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
		g_value_set_string (value, usage_storage_view_item_get_style_class (self));
		break;
		case USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY:
		g_value_set_boolean (value, usage_storage_view_item_get_show_check_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_usage_storage_view_item_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
	switch (property_id) {
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
		usage_storage_view_item_set_percentage (self, g_value_get_double (value));
		break;
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
		usage_storage_view_item_set_loaded (self, g_value_get_boolean (value));
		break;
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
		usage_storage_view_item_set_color (self, g_value_get_boxed (value));
		break;
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
		usage_storage_view_item_set_style_class (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

